
        LIST    P=16F84

RTCC    EQU 1
PC      EQU 2
STATUS  EQU 3      ;STATUS REGISTER
PORTB   EQU 6
PORTA   EQU 5 

COUNT EQU 0CH
THIRTYTWO  EQU 0DH

        ORG 0



     

       MOVLW B'10000000'
       TRIS PORTB
 
       
       BSF PORTB,0
       BSF PORTB,1
       BSF PORTB,2
       CALL SECOND

       BCF PORTB,0
       BCF PORTB,1
       BCF PORTB,2
       CALL SECOND
 

CYCLE

       MOVLW B'00000101' ; 64 MICROSECONDS 100 US = 10KHZ
       OPTION

AGAIN
       BCF PORTB,0
       BCF PORTB,1
       BCF PORTB,2
       CLRF RTCC

ABCDE  BTFSS PORTB,7
       GOTO  ABCDE
       ;LOW START TIMING

GGH    BTFSC PORTB,7
       GOTO  GGH


       BTFSC RTCC,1
       GOTO MIDD
       BTFSC RTCC,3    
       GOTO TREBLE
       BTFSC RTCC,5   
       GOTO BASS


       GOTO CYCLE


MIDD    BSF PORTB,1
        CALL ZING
        GOTO AGAIN

TREBLE
        BSF PORTB,0
        CALL ZING
        GOTO AGAIN

BASS
        BSF PORTB,2
        CALL ZING
        GOTO AGAIN

ZING   MOVLW 0FFH
       MOVWF COUNT
LONG
       DECFSZ COUNT,1
       GOTO LONG
       RETLW 0



SECOND
    MOVLW B'00000111';  PRESCALER 00000111 (/256)
    OPTION
    CLRF RTCC

    MOVLW .16
    MOVWF THIRTYTWO  ;COUNTER

SHORT BTFSC RTCC,7   ;TEST FOR 128 DECIMAL
                     ;I.E. BIT 7 = HIGH
      GOTO JMP2
 
      GOTO SHORT

JMP2 CLRF RTCC
                     ;32 LOOP COUNTER
    DECFSZ THIRTYTWO,1
    GOTO SHORT
    RETLW 0


     END
