
        LIST    P=12C508

RTCC    EQU 1
PC EQU 2
STATUS EQU 3      ;STATUS REGISTER
GPIO   EQU 6      ;PORT
OSCAL  EQU 5



 
SECS   EQU 0CH
 

#DEFINE RED GPIO,0
#DEFINE REDB GPIO,4

#DEFINE GREEN GPIO,1
#DEFINE GREENB GPIO,5

#DEFINE BLUE GPIO,2


        ORG 0

     MOVWF OSCAL
     CLRF GPIO
     MOVLW 0
     TRIS GPIO

       MOVLW B'00000111'
       OPTION

CYCLE
     BCF RED
     BCF REDB
     BCF GREEN
     BCF GREENB
     BCF BLUE

     BSF BLUE
     CALL DELAY5SEC
     BSF GREEN
     CALL DELAY5SEC
     BSF RED
     CALL DELAY5SEC


      BCF GREEN
      BCF BLUE
      BCF RED


      BSF REDB
      CALL DELAY5SEC
      BSF GREENB
      CALL DELAY5SEC
      BSF GREEN
      BSF RED
      CALL DELAY5SEC
      CALL DELAY5SEC
      BCF RED
      BCF REDB
      BCF GREEN
      BCF GREENB


      BSF BLUE
      CALL DELAY5SEC
      BSF GREEN
      CALL DELAY5SEC
      CALL DELAY5SEC
      BSF RED
      CALL DELAY5SEC
      CALL DELAY5SEC
      BCF GREEN
      BCF GREENB
      CALL DELAY5SEC
      CALL DELAY5SEC
      BCF RED
      BCF REDB
      CALL DELAY5SEC
      CALL DELAY5SEC



     
 
     BSF RED
     CALL DELAY5SEC
     BCF RED
     CALL DELAY5SEC

     BSF RED
     BSF REDB
     CALL DELAY5SEC
     BCF RED
     BCF REDB

     CALL DELAY5SEC
    

 
     BSF GREEN
     CALL DELAY5SEC
     BCF GREEN
     CALL DELAY5SEC

     BSF GREEN
     BSF GREENB
     CALL DELAY5SEC
     BCF GREEN
     BCF GREENB

     CALL DELAY5SEC
      

 
     BSF BLUE
     CALL DELAY5SEC
     BCF BLUE
     CALL DELAY5SEC

     CALL DELAY5SEC
     GOTO CYCLE



DELAY5SEC
       MOVLW B'00000111'
       OPTION
       CLRF RTCC

       MOVLW   10   ;10
       MOVWF SECS

WAIT   CLRF RTCC
WAIT1  CLRWDT
       BTFSS RTCC,7
       GOTO WAIT1
       CLRF RTCC
       DECFSZ SECS,1
       GOTO WAIT
       RETLW 0

 


     END
