


        LIST    p=16F84


BAUD_1 EQU .28    ; 30  9600 BAUD 1 BIT PERIOD
BAUD_1ST EQU .42  ; 45  BITS

PC EQU 2
PTION EQU 081H
INTCON EQU 0BH

RTCC      EQU 1      ;RTCC
STATUS    EQU 3      ;STATUS REGISTER


DLYCNT EQU 0FH
THIRTYTWO EQU 010H   ;MODULUS 32 COUNTER

BUZZ   EQU 011H
TONE   EQU 012H
MSEC_20 EQU 013H
DB1 EQU 014H
GP  EQU 015H
DB2 EQU 016H
TONE2 EQU 017H
COUNTR   EQU 018H

LBYTE EQU 019H
HBYTE EQU 01AH
LONG EQU 01BH

SAVE EQU 01CH
SAVE2 EQU 01DH
DATABYTE EQU 01EH
BUFFER EQU 01FH
DATABYTE2 EQU 020H


LED EQU 0

PORTA EQU 5
PORTB EQU 6

LSN EQU 0
MSN EQU 1



        ORG 0
        GOTO COMMS

        ORG 4
     BCF INTCON,1

      BCF INTCON,7
    MOVLW 8          ;8 DATA BITS
    MOVWF COUNTR
    CLRF BUFFER
    CALL DELAY1ST

BITS
    BCF STATUS,0
    RRF BUFFER
    BTFSC PORTB,0
    BSF BUFFER,7
    CALL DELAY
    DECFSZ COUNTR,1
    GOTO BITS

    MOVLW 0FFH
    XORWF BUFFER,0

   MOVWF DATABYTE
   MOVWF DATABYTE2



    MOVLW 0FH
    ANDWF DATABYTE,0
    MOVWF LBYTE

    SWAPF DATABYTE2,1
    MOVLW 0FH
    ANDWF DATABYTE2,0

    MOVWF HBYTE



    BCF INTCON,1
      BSF INTCON,7
    RETFIE


COMMS
      MOVLW B'00000001'
      TRIS PORTB


      MOVLW 0
      TRIS PORTA


     BSF INTCON,4
     BSF PTION,6

      BSF PORTA,3   ;MSN
      BSF PORTA,0   ;LSN

      MOVLW 0FFH    ;ALL SEGMENTS OFF
      MOVWF PORTB


      MOVLW B'01000111'
      OPTION



      BSF PORTA,3   ;MSN  ON
      BSF PORTA,0   ;LSN  ON

      MOVLW 0      ;ALL SEGMENTS ON
      MOVWF PORTB
      CALL SECOND


      MOVLW 0FFH   ;ALL SEGMENTS OFF
      MOVWF PORTB
      CALL SECOND

     BSF INTCON,7

     MOVLW 0
     MOVWF DATABYTE
XXX
     CALL ALL
     GOTO XXX


ALL



      BCF PORTA,3   ;MSN  ON
      BSF PORTA,0   ;LSN  ON

   MOVF LBYTE,0
   CALL SEGMENTS
   MOVWF PORTB

   CALL MUX

      BSF PORTA,3   ;MSN  ON
      BCF PORTA,0   ;LSN  ON

   MOVF HBYTE,0
   CALL SEGMENTS
   MOVWF PORTB

   CALL MUX

    RETLW 0


SEGMENTS
    ADDWF PC

    RETLW 02H
    RETLW 09EH
    RETLW 024H
    RETLW 0CH
    RETLW 098H
    RETLW 048H
    RETLW 040H
    RETLW 01EH
    RETLW 0
    RETLW 018H
    RETLW 010H
    RETLW 0C0H
    RETLW 062H
    RETLW 084H
    RETLW 060H
    RETLW 070H



SECOND
    MOVLW .2   ;32
    MOVWF THIRTYTWO  ;COUNTER
    CLRF RTCC        ;LOAD RTCC

SHORT BTFSC RTCC,7   ;TEST FOR 128 DECIMAL
                     ;I.E. BIT 7 = HIGH
      GOTO JMP2
      CLRWDT
      GOTO SHORT

JMP2 CLRF RTCC
                     ;32 LOOP COUNTER
    DECFSZ THIRTYTWO,1
    GOTO SHORT
    RETLW 0


MUX
    MOVLW .4   ;32
    MOVWF THIRTYTWO  ;COUNTER
    CLRF RTCC        ;LOAD RTCC

SHORTM BTFSC RTCC,3   ;TEST FOR 128 DECIMAL
                     ;I.E. BIT 7 = HIGH
      GOTO JMP2M
      CLRWDT
      GOTO SHORTM

JMP2M CLRF RTCC
                     ;32 LOOP COUNTER
    DECFSZ THIRTYTWO,1
    GOTO SHORTM
    RETLW 0



DELAY

     MOVLW BAUD_1
     MOVWF DLYCNT
REDO DECFSZ DLYCNT,1
    GOTO REDO
    RETLW 0



DELAY1ST

     MOVLW BAUD_1ST
     MOVWF DLYCNT
REDX DECFSZ DLYCNT,1
    GOTO REDX
    RETLW 0


     END

