Program egg5.asm

        LIST    p=16f84

RTCC      EQU 1      ;RTCC
STATUS    EQU 3      ;STATUS REGISTER
THIRTYTWO EQU 010H   ;MODULUS 32 COUNTER

BUZZ   EQU 011H
TONE   EQU 012H
MSEC_20 EQU 013H
DB1 EQU 014H
GP  EQU 015H
DB2 EQU 016H
TONE2 EQU 017H


PORTA EQU 5
PORTB EQU 6


SCAN1 EQU 2
SW1   EQU 0



        ORG 0
    MOVLW 0
    TRIS  PORTB
    MOVLW 0
    MOVWF PORTB

     MOVLW 1
     TRIS PORTA
     MOVLW 0FFH
     MOVWF PORTA
     BCF PORTA,1

 BSF PORTA,SCAN1
KEYON

  CALL DELAY
  BCF PORTA,SCAN1

  CLRWDT
  BTFSC PORTA,0
  GOTO CONT
  BSF PORTA,SCAN1

  CALL SWITCH


DEBOUNCE
  BSF PORTA,SCAN1
  CALL DELAY
  BCF PORTA,SCAN1
  CLRWDT
  BTFSS PORTA,0
  GOTO DEBOUNCE

CONT

  BCF PORTA,SCAN1

 MOVLW 0
 MOVWF PORTB
  BCF PORTA,1
  BCF PORTA,3
  SLEEP


DELAY
  MOVLW MSEC_20
  MOVWF DB1

DLY1
   CLRWDT
   CLRF DB2
   DECFSZ DB1
   GOTO DLY2
   RETLW 0

DLY2
 CLRWDT

 DECFSZ DB2
 GOTO DLY2
 GOTO DLY1

SWITCH

    MOVLW B'00000111';  PRESCALER 00000111 (/256)
    OPTION
    CLRF RTCC
    CLRWDT
   CALL ALARM
   CALL QUARTER
   CALL ALARM
   CALL QUARTER
   CALL ALARM


    BSF PORTB,1
    CALL QUARTER
    BCF PORTB,1
    BSF PORTB,7
    CALL QUARTER
    BCF PORTB,7
    BSF PORTB,5
    CALL QUARTER
    BCF PORTB,5
    BSF PORTB,3
    CALL QUARTER
    BCF PORTB,3
    BSF PORTB,0
    CALL QUARTER
    BCF PORTB,0
    BSF PORTB,2
    CALL QUARTER
    BCF PORTB,2
    BSF PORTB,4
    CALL QUARTER
    BCF PORTB,4
    BSF PORTA,6
    CALL QUARTER
    BCF PORTA,6


    ;4 MIN

    BSF PORTB,2
    BSF PORTB,6
    BSF PORTB,7
    BSF PORTB,5

    CALL SECOND
    CALL SECOND

    BCF PORTB,2
    BCF PORTB,6
    BCF PORTB,7
    BCF PORTB,5


     CALL MIN
     CALL MIN
     CALL MIN
     CALL MIN
     CALL MIN

    MOVLW 5
    MOVWF TONE

NN
     BSF PORTB,1
     CALL ALARM
     CALL QUARTER
     BSF PORTB,7
     CALL ALARM
     CALL QUARTER
     BSF PORTB,5
     CALL ALARM
     CALL QUARTER
     BSF PORTB,3
     CALL ALARM
     CALL QUARTER
     BSF PORTB,0
     CALL ALARM
     CALL QUARTER
     BSF PORTB,2
     CALL ALARM
     CALL QUARTER
                      ;EGG BOILED

      CALL QUARTER

     BCF PORTB,1
     BCF PORTB,7
     BCF PORTB,5
     BCF PORTB,3
     BCF PORTB,0
     BCF PORTB,2

      CALL QUARTER

     DECFSZ TONE,1
     GOTO NN
     RETLW 0


ALARM
     MOVLW 0FFH
     MOVWF TONE2
JJ
     MOVLW 042H
     MOVWF BUZZ
     BSF PORTA,1
GG   DECFSZ BUZZ,1
     GOTO GG
     BCF PORTA,1
     MOVLW 042H
     MOVWF BUZZ
HH   DECFSZ BUZZ,1
     GOTO HH
     DECFSZ TONE2,1
      GOTO JJ

    RETLW 0



MIN  MOVLW .60     ;1 MINUTE
     MOVWF TONE

COUNT   BSF PORTB,4
    MOVLW .30  ;32
    MOVWF THIRTYTWO  ;COUNTER
    CLRF RTCC        ;LOAD RTCC

AHORT BTFSC RTCC,7   ;TEST FOR 128 DECIMAL
                     ;I.E. BIT 7 = HIGH
      GOTO JMP3
      CLRWDT
      BTFSC RTCC,6
      BCF PORTB,4

      GOTO AHORT

JMP3 CLRF RTCC
                     ;32 LOOP COUNTER
    DECFSZ THIRTYTWO,1
    GOTO AHORT
    DECFSZ TONE,1
    GOTO COUNT

    RETLW 0




SECOND
    MOVLW .30  ;32
    MOVWF THIRTYTWO  ;COUNTER
    CLRF RTCC        ;LOAD RTCC

SHORT BTFSC RTCC,7   ;TEST FOR 128 DECIMAL
                     ;I.E. BIT 7 = HIGH
      GOTO JMP2
      CLRWDT
      GOTO SHORT

JMP2 CLRF RTCC
                     ;32 LOOP COUNTER
    DECFSZ THIRTYTWO,1
    GOTO SHORT
    RETLW 0

QUARTER
    MOVLW .2
    MOVWF THIRTYTWO  ;COUNTER
    CLRF RTCC        ;LOAD RTCC

BHORT BTFSC RTCC,7   ;TEST FOR 128 DECIMAL
                     ;I.E. BIT 7 = HIGH
      GOTO JMP5
      CLRWDT
      GOTO BHORT

JMP5 CLRF RTCC
                     ;32 LOOP COUNTER
    DECFSZ THIRTYTWO,1
    GOTO BHORT
    RETLW 0


     END










