;INTRC WDT DIS MCR DIS
     LIST    p=12C508
 
RTCC      EQU 1      ;RTCC
STATUS    EQU 3      ;STATUS REGISTER
THIRTYTWO EQU 010H   ;MODULUS 32 COUNTER

BUZZ   EQU 011H
TONE   EQU 012H
MSEC_20 EQU 013H
DB1 EQU 014H
GP  EQU 015H
DB2 EQU 016H
TONE2 EQU 017H
COUNTR   EQU 018H

LED EQU 0
GPIO EQU 6
OSCAL EQU 5



SCAN1 EQU 2
SW1   EQU 0



        ORG 0

    MOVWF OSCAL
    CLRF GPIO

    MOVLW 8
    TRIS GPIO

     CALL MS15
     CALL MS15
     CALL MS15
     CALL MS15
     CALL MS15

     BTFSS GPIO,3
     GOTO SWITCH
REP
     MOVLW B'00000111'
     OPTION

      BCF GPIO,0
      BCF GPIO,1
      BCF GPIO,2
      BCF GPIO,4
      BCF GPIO,5
      SLEEP


SWITCH

     CALL DEBOUNCE

    MOVLW B'10000111';  PRESCALER 00000111 (/256)
    OPTION
    CLRF RTCC
    CLRWDT

   CALL ALARM
   BSF GPIO,0
   CALL QUARTER
   BCF GPIO,0

   CALL ALARM
   BSF GPIO,0
   CALL QUARTER
   BCF GPIO,0


    ;20 MINUTES
     CALL MIN
     CALL MIN
     CALL MIN
     CALL MIN
     CALL MIN
     CALL MIN
     CALL MIN
     CALL MIN
     CALL MIN
     CALL MIN
     CALL MIN
     CALL MIN
     CALL MIN
     CALL MIN
     CALL MIN
     CALL MIN
     CALL MIN
     CALL MIN
     CALL MIN
     CALL MIN
     CALL MIN





    MOVLW 10
    MOVWF TONE

NN
     BSF GPIO,0
     CALL ALARM
     CALL QUARTER
     BCF GPIO,0
     CALL ALARM
     CALL SECOND
     DECFSZ TONE,1
     GOTO NN

     GOTO REP


ALARM
     MOVLW 0FFH
     MOVWF TONE2
JJ
     MOVLW 042H
     MOVWF BUZZ
     BSF GPIO,1
GG   DECFSZ BUZZ,1
     GOTO GG
     BCF GPIO,1
     MOVLW 042H
     MOVWF BUZZ
HH   DECFSZ BUZZ,1
     GOTO HH
     DECFSZ TONE2,1
      GOTO JJ

    RETLW 0



MIN  MOVLW .60     ;1 MINUTE
     MOVWF TONE

COUNT   BSF GPIO,0
    MOVLW .32  ;32
    MOVWF THIRTYTWO  ;COUNTER
    CLRF RTCC        ;LOAD RTCC

AHORT BTFSC RTCC,7   ;TEST FOR 128 DECIMAL
                     ;I.E. BIT 7 = HIGH
      GOTO JMP3
      CLRWDT
      BTFSC RTCC,6
      BCF GPIO,0

      GOTO AHORT

JMP3 CLRF RTCC
                     ;32 LOOP COUNTER
    DECFSZ THIRTYTWO,1
    GOTO AHORT
    DECFSZ TONE,1
    GOTO COUNT

    RETLW 0




SECOND
    MOVLW .30  ;32
    MOVWF THIRTYTWO  ;COUNTER
    CLRF RTCC        ;LOAD RTCC

SHORT BTFSC RTCC,7   ;TEST FOR 128 DECIMAL
                     ;I.E. BIT 7 = HIGH
      GOTO JMP2
      CLRWDT
      GOTO SHORT

JMP2 CLRF RTCC
                     ;32 LOOP COUNTER
    DECFSZ THIRTYTWO,1
    GOTO SHORT
    RETLW 0

QUARTER
    MOVLW .2
    MOVWF THIRTYTWO  ;COUNTER
    CLRF RTCC        ;LOAD RTCC

BHORT BTFSC RTCC,7   ;TEST FOR 128 DECIMAL
                     ;I.E. BIT 7 = HIGH
      GOTO JMP5
      CLRWDT
      GOTO BHORT

JMP5 CLRF RTCC
                     ;32 LOOP COUNTER
    DECFSZ THIRTYTWO,1
    GOTO BHORT
    RETLW 0

DEBOUNCE
      CALL MS15
      BTFSS GPIO,3
      GOTO DEBOUNCE
      RETLW 0

MS15 MOVLW 0FFH
     MOVWF COUNTR
LOOP5

     NOP
     NOP
     NOP
     NOP
     NOP
     DECFSZ COUNTR,1
     GOTO LOOP5
     RETLW 0

     END










