/* ==========================================================================*/
/* - - - - - - - - - - - -  M E N U , H  - - - - - - - - - - - - - - - - - - */
/* ==========================================================================*/
/*	Created   07-10-2004   M. Wheatley                                       */
/*	Modified  07-10-2004   MW                                                */
/*.........................................................................  */
/* MENU Module Include File                                                  */
/*.........................................................................  */
#ifndef MENU_MODULE
#define MENU_MODULE

/*>>>>>>>>>>>>>>>>>>>>>> Global Defines <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/

#define MENU_MAIN 0
#define MENU_SETUP 1
#define MENU_STATUS 2
#define MENU_SETTIME 3
#define MENU_SIGNAL 4
#define MENU_SYNC 5
#define MENU_DATA 6

/*>>>>>>>>>>>>>>>>>>>>>>> External memory <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/
extern unsigned char CurrentMenu;
extern void DisplayTime( void);

/*>>>>>>>>>>>>>>>>>>>>>> External functions <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/
extern void InitMenu( void );
extern void ServiceMenu(void);

#endif

