#include <p18f252.inc>  

    	CODE
 
 
 
asm_rom2
	
 


 


 
DO EQU 6
DI EQU 7


BCOUNT EQU 023H
MSB EQU 024H
LSB EQU 025H
SLAVE EQU 026H
COUNTR EQU 027H
DLYCNT EQU 028H
BUFFER EQU 02FH
TXBUF EQU 02AH
DATAI EQU 02BH
ADDR EQU 02CH
EEPROM EQU 02DH
COMPASS EQU 02EH
 

;POLL EQU 1
;WR EQU 2
;SCL EQU 0
;SDA EQU 3

        

 ;BSF PORTB,4
 BSF PORTB,5
  
 

   MOVLW B'00000000'     ;WRITE
   MOVWF TRISC  
  MOVLW 0F0H
  MOVWF PORTC


   ; MOVLW B'01000111';  PRESCALER 00000111 (/256)
   ; OPTION

   ; BSF PORTA,2


EVER

     MOVLW B'11000000'
     MOVWF SLAVE

     MOVLW 1
    MOVWF ADDR

     CALL BSTART
     MOVF SLAVE,W
     MOVWF TXBUF
     CALL TXX
           CALL DELAY

     MOVF ADDR,W
    MOVWF TXBUF
     CALL TXX

           CALL DELAY



     CALL BSTART

    MOVLW B'11000001'
    MOVWF TXBUF
     CALL TXX

 ; BSF EEPROM,DO
 ;  CALL BITOUT

    CALL DELAY


     CALL RXX
    MOVF DATAI,0


                             ; MOVLW 081H
      MOVWF COMPASS

 ;  MOVWF PORTB


    BSF EEPROM,DO
    CALL BITOUT

     CALL BSTOP
     CALL DELAY


 ; BUG BTFSC PORTA,1
    ;  GOTO BUG

 ;   BCF PORTA,2
  ;  BSF PORTA,2

   GOTO EVERT

;
 




DELAY                           ;104 uS DELAY
      MOVLW .250
      MOVWF DLYCNT
REDO DECFSZ DLYCNT,1
      goto REDO

    MOVLW .250
      MOVWF DLYCNT
REDO1 DECFSZ DLYCNT,1
      goto REDO1



   MOVLW .250
      MOVWF DLYCNT
REDO11 DECFSZ DLYCNT,1
      goto REDO11




   MOVLW .250
      MOVWF DLYCNT
REDO12 DECFSZ DLYCNT,1
      goto REDO12

      retlw 0




BITIN
    BSF EEPROM,DI
    MOVLW B'00001000'         ;SCL 0  SDA 1
       MOVWF  TRISC  

     BSF PORTC,3
    BSF PORTC,0
     
    BTFSS PORTC,3
    BCF EEPROM,DI
    BCF PORTC,0
    RETLW 0

BITOUT
        MOVLW B'00000000'       ;SCL 0  SDA 0
        MOVWF TRISC  

    BTFSS EEPROM,DO
    GOTO BITLOW
    BSF PORTC,3
    GOTO CLKOUT

BITLOW BCF PORTC,3
CLKOUT BSF PORTC,0
 NOP       
   NOP
   NOP
   NOP
   NOP
   NOP

       BCF PORTC,0
      RETLW 0


BSTART
    MOVLW B'00000000'       ;SCL 0 SDA 0
       MOVWF TRISC 

   BSF PORTC,3
   NOP       
   NOP
   NOP
   NOP
   NOP
   NOP

   BCF PORTC,0
   NOP
 NOP       
   NOP
   NOP
   NOP
   NOP
   NOP

   BSF PORTC,0
        BCF PORTC,3
   NOP
 NOP       
   NOP
   NOP
   NOP
   NOP
   NOP

        BCF PORTC,0
 NOP       
   NOP
   NOP
   NOP
   NOP
   NOP

   RETLW 0



BSTOP
    MOVLW B'00000000'       ;SCL 0  SDA 0
      MOVWF TRISC  

   BCF PORTC,3
   NOP
 NOP       
   NOP
   NOP
   NOP
   NOP
   NOP

   BSF PORTC,0
   NOP
 NOP       
   NOP
   NOP
   NOP
   NOP
   NOP

    BSF PORTC,3
   NOP
 NOP       
   NOP
   NOP
   NOP
   NOP
   NOP

        BCF PORTC,0
 NOP       
   NOP
   NOP
   NOP
   NOP
   NOP

          RETLW 0


TXX
    MOVLW B'00000000'     ;SCL 0 SDA 0
      MOVWF TRISC  

     MOVLW .8
     MOVWF COUNTR
TXLP BCF EEPROM,DO
     BTFSC TXBUF,7
     BSF EEPROM,DO
     CALL BITOUT
     RLCF TXBUF,1
     DECFSZ COUNTR
     GOTO TXLP
     CALL BITIN
     BTFSC EEPROM,DI
     NOP
 NOP       
   NOP
   NOP
   NOP
   NOP
   NOP

    RETLW 0


RXX
        MOVLW B'00001000'     ;SCL 0   SDA 1
        MOVWF TRISC  

   CLRF DATAI
   MOVLW .8
   MOVWF COUNTR
CON BCF STATUS,0
    RLCF DATAI,1
   BSF PORTC,3
 NOP       
   NOP
   NOP
   NOP
   NOP
   NOP

   BSF PORTC,0
    BTFSC PORTC,3
    BSF DATAI,0
    BCF PORTC,0
    DECFSZ COUNTR,1
    GOTO CON

   RETLW 0



EVERT 

 MOVF COMPASS,0
 
	RETURN

 GLOBAL asm_rom2

	END
