
 

	processor  16F84
 

TMR0        EQU   0x01
PC EQU 2 
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
OPTION_REG  EQU   0x81
RA0         EQU   0  ;data
RA1         EQU   1  ;clk
RA2         EQU   2  ;d/c
RA3         EQU   3  ;ce
RA4         EQU   4   ;now rb3
RB3         EQU   3
RB0          EQU 0
RB1         EQU 1


status equ 3
command_in  EQU   0x10
data_in     EQU   0x11
bits_in     EQU   0x12
bitcnt      EQU   0x13
ddram       EQU   0x14
x           EQU   0x15
y           EQU   0x16
n           EQU   0x17
i_2         EQU   0x18
counter      EQU 019H
counter2    equ 01ah
char equ  01ch
save2   equ  01dh

count1 equ 0ch
count2 equ 0dh
count3 equ 0eh

save equ 01bh


PORTB EQU 6
PORT_A EQU 5
 			  
    
 

  
	org	0
 
 
     goto init

    org 4
    retfie
;------------------------------------------------------------
init   

    	CALL  delay100
   bcf 0bh,1
   movlw b'00000111'
   movwf 081h	
   bcf 081h,6	 ;enable sleep and rb0 oint
   bsf 0bh,4	

here

	movlw   1
	tris    PORTB ; set portb as output
      movwf   PORTB ; all ouput low
	movlw   0
	tris    PORT_A ; set portb as output
      movwf   PORT_A ; all ouput low
  bcf 0bh,7
 bsf PORTB,4  ;led off
   sleep
  nop
    
   bcf 0bh,4   ;disable rb0 int
      
debounce2
 
 	CALL  delay100
 	btfss PORTB,0
 	goto debounce2



start	 
    bcf PORTB,4  ;led on
	bsf	  PORT_A,RA2                      ;dorc
	bsf   PORT_A,RA3                      ;ENEB
	 
;	bsf	tens ;activare tensiune

	call lcres	;resetare cca. 250ms

	movlw 21H	;set extins 
	 CALL LCD_SENDCMD
	movlw  0c8h                         ;.197(C5)	;Vop  A0,c8
	 CALL LCD_SENDCMD
	movlw 013H	;bias                         ;   13h
	 CALL LCD_SENDCMD
	movlw 20H	;afisare orizontala
	 CALL LCD_SENDCMD
	movlw 09H	;mod control all on 
	 CALL LCD_SENDCMD
 	movlw 08H	;mod control blank 
      CALL LCD_SENDCMD


 ;	CALL cbild

    call delay10

 	movlw 0CH	;mod control normal 
    CALL LCD_SENDCMD
 	movlw 40H	;x ini 
     CALL LCD_SENDCMD
 	movlw 80H	;y ini
    CALL LCD_SENDCMD
   bsf	PORTB,3     ;dezactivare reset


 	movlw 9
    CALL LCD_SENDCMD
	CALL  delay100
	CALL  delay100
 	CALL  delay100


    	CALL  delay100
;	CALL  delay100
  



    	movlw 0ch
     CALL LCD_SENDCMD
     
    ;9 all on
    ;8 blank


	movlw 07fh
 call LCD_SENDDATA
	movlw 9
 call LCD_SENDDATA
	movlw 9
 call LCD_SENDDATA
	movlw 9
 call LCD_SENDDATA
	movlw 1
 call LCD_SENDDATA

	movlw 0
 call LCD_SENDDATA
	movlw 0


 call LCD_SENDDATA
 	movlw 07FH
 call LCD_SENDDATA
	movlw 049H
 call LCD_SENDDATA
	movlw 049h
 call LCD_SENDDATA
	movlw 049h
 call LCD_SENDDATA
	movlw 041H
 call LCD_SENDDATA


     movlw 0
	call LCD_SENDDATA


     movlw 0
	call LCD_SENDDATA



	movlw 03EH
    call LCD_SENDDATA
	movlw 041H
    call LCD_SENDDATA
	movlw 041H
    call LCD_SENDDATA
	movlw 041H
    call LCD_SENDDATA
	movlw 032H
    call LCD_SENDDATA
	 


  movlw 0
	call LCD_SENDDATA


     movlw 0
	call LCD_SENDDATA



	movlw 014H
    call LCD_SENDDATA
	movlw 014H
    call LCD_SENDDATA
	movlw 014H
    call LCD_SENDDATA
	movlw 014H
    call LCD_SENDDATA
	movlw 014H
    call LCD_SENDDATA



 movlw 0
	call LCD_SENDDATA



	movlw 0 
    call LCD_SENDDATA
	movlw 042H
    call LCD_SENDDATA
	movlw 07FH
    call LCD_SENDDATA
	movlw 040H
    call LCD_SENDDATA
	movlw 0 
    call LCD_SENDDATA


 movlw 0
	call LCD_SENDDATA



	movlw 021H
    call LCD_SENDDATA
	movlw 041H
    call LCD_SENDDATA
	movlw 045H
    call LCD_SENDDATA
	movlw 04BH
    call LCD_SENDDATA
	movlw 031H
    call LCD_SENDDATA

 movlw 0
	call LCD_SENDDATA



	movlw 018H
    call LCD_SENDDATA
	movlw 014H
    call LCD_SENDDATA
	movlw 012H
    call LCD_SENDDATA
	movlw 07FH
    call LCD_SENDDATA
	movlw 010H
    call LCD_SENDDATA


 movlw 0
	call LCD_SENDDATA



	movlw 0 
    call LCD_SENDDATA
	movlw 042H
    call LCD_SENDDATA
	movlw 07FH
    call LCD_SENDDATA
	movlw 040H
    call LCD_SENDDATA
	movlw 0 
    call LCD_SENDDATA



  movlw .34
 	movwf counter2

 
ALPHA2221 
    movlw 1 
    call LCD_SENDDATA


 DECFSZ counter2,1
 	GOTO ALPHA2221

 



   movlw 0
	call LCD_SENDDATA



	movlw 03EH 
    call LCD_SENDDATA
	movlw 051H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw  045H;                   045H
    call LCD_SENDDATA
	movlw 03EH 
    call LCD_SENDDATA


 movlw 0
	call LCD_SENDDATA



	movlw 036H 
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 036H 
    call LCD_SENDDATA


 movlw 0
	call LCD_SENDDATA



	movlw 1 
    call LCD_SENDDATA
	movlw 071H
    call LCD_SENDDATA
	movlw 09H
    call LCD_SENDDATA
	movlw 5
    call LCD_SENDDATA
	movlw 3
    call LCD_SENDDATA


 movlw 0
	call LCD_SENDDATA



	movlw 03EH 
    call LCD_SENDDATA
	movlw 051H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 045H
    call LCD_SENDDATA
	movlw 03EH 
    call LCD_SENDDATA


 movlw 0
	call LCD_SENDDATA



	movlw 0 
    call LCD_SENDDATA
	movlw 042H
    call LCD_SENDDATA
	movlw 07FH
    call LCD_SENDDATA
	movlw 040H
    call LCD_SENDDATA
	movlw 0 
    call LCD_SENDDATA




 movlw 0
	call LCD_SENDDATA



	movlw 042H
    call LCD_SENDDATA
	movlw 061H
    call LCD_SENDDATA
	movlw 051H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 046H 
    call LCD_SENDDATA





 movlw 0
	call LCD_SENDDATA



	movlw 03EH 
    call LCD_SENDDATA
	movlw 051H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 045H
    call LCD_SENDDATA
	movlw 03EH 
    call LCD_SENDDATA


 movlw 0
	call LCD_SENDDATA



	movlw 03EH 
    call LCD_SENDDATA
	movlw 051H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 045H
    call LCD_SENDDATA
	movlw 03EH 
    call LCD_SENDDATA




 movlw 0
	call LCD_SENDDATA



	movlw 042H
    call LCD_SENDDATA
	movlw 061H
    call LCD_SENDDATA
	movlw 051H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 046H 
    call LCD_SENDDATA




 movlw 0
	call LCD_SENDDATA



	movlw 03EH 
    call LCD_SENDDATA
	movlw 051H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 045H
    call LCD_SENDDATA
	movlw 03EH 
    call LCD_SENDDATA





 movlw 0
	call LCD_SENDDATA



	movlw 03EH 
    call LCD_SENDDATA
	movlw 051H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 045H
    call LCD_SENDDATA
	movlw 03EH 
    call LCD_SENDDATA



    	movlw 080H	;mod control blank                          ;x =0
      CALL LCD_SENDCMD

  	movlw 042H	;mod control blank                              ;y= page 2
      CALL LCD_SENDCMD




 movlw 0               ;J
	call LCD_SENDDATA



	movlw 020H 
    call LCD_SENDDATA
	movlw 040H
    call LCD_SENDDATA
	movlw 041H
    call LCD_SENDDATA
	movlw 03FH
    call LCD_SENDDATA
	movlw 1
    call LCD_SENDDATA



 movlw 0                  ;F
	call LCD_SENDDATA



	movlw 07FH 
    call LCD_SENDDATA
	movlw 9
    call LCD_SENDDATA
	movlw 9
    call LCD_SENDDATA
	movlw 9
    call LCD_SENDDATA
	movlw 1
    call LCD_SENDDATA


 movlw 0                   ;6
	call LCD_SENDDATA



	movlw 03CH 
    call LCD_SENDDATA
	movlw 04AH
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 030H 
    call LCD_SENDDATA



 movlw 0                   ;6
	call LCD_SENDDATA



	movlw 03CH 
    call LCD_SENDDATA
	movlw 04AH
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 030H 
    call LCD_SENDDATA




 movlw 0                   ;8
	call LCD_SENDDATA



	movlw 036H 
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 036H 
    call LCD_SENDDATA




 movlw 0                   ;2
	call LCD_SENDDATA



	movlw 042H 
    call LCD_SENDDATA
	movlw 061H
    call LCD_SENDDATA
	movlw 051H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 046H 
    call LCD_SENDDATA



 movlw 0                   ;5
	call LCD_SENDDATA



	movlw 027H 
    call LCD_SENDDATA
	movlw 045H
    call LCD_SENDDATA
	movlw 045H
    call LCD_SENDDATA
	movlw 045H
    call LCD_SENDDATA
	movlw 039H 
    call LCD_SENDDATA


 movlw 0                   ;8
	call LCD_SENDDATA



	movlw 036H 
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 036H 
    call LCD_SENDDATA



 movlw 0                   ;8
	call LCD_SENDDATA



	movlw 036H 
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 036H 
    call LCD_SENDDATA



	movlw 010H                        ;-
    call LCD_SENDDATA
	movlw 010H
    call LCD_SENDDATA
	movlw 010H
    call LCD_SENDDATA
	movlw 010H
    call LCD_SENDDATA
	movlw 010H 
    call LCD_SENDDATA




	movlw 0                         ;1
    call LCD_SENDDATA
	movlw 042H
    call LCD_SENDDATA
	movlw 07FH
    call LCD_SENDDATA
	movlw 040H
    call LCD_SENDDATA
	movlw 0 
    call LCD_SENDDATA






    	movlw 080H	;mod control blank                          ;x =0
      CALL LCD_SENDCMD

  	movlw 043H	;mod control blank                              ;y= page 2
      CALL LCD_SENDCMD











 movlw 0                   ;0
	call LCD_SENDDATA



	movlw 03EH 
    call LCD_SENDDATA
	movlw 051H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 045H
    call LCD_SENDDATA
	movlw 03EH 
    call LCD_SENDDATA



 movlw 0                   ;8
	call LCD_SENDDATA



	movlw 036H 
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 036H 
    call LCD_SENDDATA


    movlw 0                   ;0
	call LCD_SENDDATA



	movlw 03EH 
    call LCD_SENDDATA
	movlw 051H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 045H
    call LCD_SENDDATA
	movlw 03EH 
    call LCD_SENDDATA



   movlw 0                   ;0
	call LCD_SENDDATA



	movlw 03EH 
    call LCD_SENDDATA
	movlw 051H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 045H
    call LCD_SENDDATA
	movlw 03EH 
    call LCD_SENDDATA

                 ;...............................702


  movlw 0                   ;7
	call LCD_SENDDATA



	movlw 1
    call LCD_SENDDATA
	movlw 071H
    call LCD_SENDDATA
	movlw 9
    call LCD_SENDDATA
	movlw 5
    call LCD_SENDDATA
	movlw 3
    call LCD_SENDDATA


  movlw 0                   ;0
	call LCD_SENDDATA



	movlw 03EH 
    call LCD_SENDDATA
	movlw 051H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 045H
    call LCD_SENDDATA
	movlw 03EH 
    call LCD_SENDDATA


 movlw 0                   ;2
	call LCD_SENDDATA



	movlw 042H 
    call LCD_SENDDATA
	movlw 061H
    call LCD_SENDDATA
	movlw 051H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 046H 
    call LCD_SENDDATA






  movlw 0                   ;7
	call LCD_SENDDATA



	movlw 1
    call LCD_SENDDATA
	movlw 071H
    call LCD_SENDDATA
	movlw 9
    call LCD_SENDDATA
	movlw 5
    call LCD_SENDDATA
	movlw 3
    call LCD_SENDDATA


  movlw 0                   ;0
	call LCD_SENDDATA



	movlw 03EH 
    call LCD_SENDDATA
	movlw 051H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 045H
    call LCD_SENDDATA
	movlw 03EH 
    call LCD_SENDDATA


 movlw 0                   ;2
	call LCD_SENDDATA



	movlw 042H 
    call LCD_SENDDATA
	movlw 061H
    call LCD_SENDDATA
	movlw 051H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 046H 
    call LCD_SENDDATA





    	movlw 080H	;mod control blank                          ;x =0
      CALL LCD_SENDCMD

  	movlw 044H	;mod control blank                              ;y= page 2
      CALL LCD_SENDCMD


 movlw 0                   ;8
	call LCD_SENDDATA



	movlw 036H 
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 036H 
    call LCD_SENDDATA


 movlw 0                   ;8
	call LCD_SENDDATA



	movlw 036H 
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 036H 
    call LCD_SENDDATA




 movlw 0
	call LCD_SENDDATA



	movlw 0 
    call LCD_SENDDATA
	movlw 042H
    call LCD_SENDDATA
	movlw 07FH
    call LCD_SENDDATA
	movlw 040H
    call LCD_SENDDATA
	movlw 0 
    call LCD_SENDDATA





 movlw 0
	call LCD_SENDDATA



	movlw 6 
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 029H
    call LCD_SENDDATA
	movlw 1EH 
    call LCD_SENDDATA





 movlw 0
	call LCD_SENDDATA



	movlw 1 
    call LCD_SENDDATA
	movlw 071H
    call LCD_SENDDATA
	movlw 9
    call LCD_SENDDATA
	movlw 5
    call LCD_SENDDATA
	movlw 3 
    call LCD_SENDDATA



	movlw 010H                        ;-
    call LCD_SENDDATA
	movlw 010H
    call LCD_SENDDATA
	movlw 010H
    call LCD_SENDDATA
	movlw 010H
    call LCD_SENDDATA
	movlw 010H 
    call LCD_SENDDATA







 movlw 0                   ;7
	call LCD_SENDDATA



	movlw 1
    call LCD_SENDDATA
	movlw 071H
    call LCD_SENDDATA
	movlw 9
    call LCD_SENDDATA
	movlw 5
    call LCD_SENDDATA
	movlw 3
    call LCD_SENDDATA




movlw 0                         ;1
    call LCD_SENDDATA
	movlw 042H
    call LCD_SENDDATA
	movlw 07FH
    call LCD_SENDDATA
	movlw 040H
    call LCD_SENDDATA
	movlw 0 
    call LCD_SENDDATA




 movlw 0                   ;8
	call LCD_SENDDATA



	movlw 036H 
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 036H 
    call LCD_SENDDATA






movlw 0                   ;6
	call LCD_SENDDATA



	movlw 03CH 
    call LCD_SENDDATA
	movlw 04AH
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 049H
    call LCD_SENDDATA
	movlw 030H 
    call LCD_SENDDATA



















;........................................................................................................................................................
         ; end of data
   
    call delay100

 	movlw 40H	;x ini 
   CALL LCD_SENDCMD
  	movlw 80H	;y ini
   CALL LCD_SENDCMD
  bsf	PORTB,3     ;dezactivare reset

  bsf PORT_A,3       


                           ;disable LCD
       call delay100
		call delay100

   
debounce
 
 	CALL  delay100
 	btfsc PORTB,0
 	goto debounce

	movlw .255
 	movwf counter2





ALPHA222 
    movlw 0 
    call LCD_SENDDATA
    	CALL  delay1                                                     ;...........................................

 DECFSZ counter2,1
 	GOTO ALPHA222




ALPHA2222 
    movlw 0 
    call LCD_SENDDATA


 DECFSZ counter2,1
 	GOTO ALPHA2222





		call delay100
		call delay100	
aaa     bcf 0bh,4
    
  goto  init

 
  


lcres
	bcf PORTB,3
	CALL delay10
	BSF PORTB,3
	RETURN

 
delay10
	MOVLW .25 
	MOVWF n
			;    char i;
			;
			;    OPTION = 7;
	MOVLW .7
	BSF   0x03,RP0
	MOVWF OPTION_REG
			;    do  {
			;        clrwdt();  // only if watchdog enabled
m007	CLRWDT
			;        i = TMR0 + 39; /* 256 microsec * 39 = 10 ms */
	MOVLW .39
	BCF   0x03,RP0
	ADDWF TMR0,W
	MOVWF i_2
			;        while ( i != TMR0)
m008	MOVF  i_2,W
	BCF   0x03,RP0
	XORWF TMR0,W
	BTFSS 0x03,Zero_
			;            ;
	GOTO  m008
			;    } while ( --n > 0);
	DECFSZ n,1
	GOTO  m007
			;}
	RETURN

delay100
	MOVLW  .50                                               ;.50
	MOVWF n
			;    char i;
			;
			;    OPTION = 7;
	MOVLW .7
	BSF   0x03,RP0
	MOVWF OPTION_REG
			;    do  {
			;        clrwdt();  // only if watchdog enabled
m007a	CLRWDT
			;        i = TMR0 + 39; /* 256 microsec * 39 = 10 ms */
	MOVLW .20
	BCF   0x03,RP0
	ADDWF TMR0,W
	MOVWF i_2
			;        while ( i != TMR0)
m008a	MOVF  i_2,W
	BCF   0x03,RP0
	XORWF TMR0,W
	BTFSS 0x03,Zero_
			;            ;
	GOTO  m008a
			;    } while ( --n > 0);
	DECFSZ n,1
	GOTO  m007a
			;}
	RETURN


LCD_SENDCMD
  movwf save
    movlw 8
	movwf counter
  bcf PORT_A,RA2
  bcf PORT_A,RA3
	call LCD_SENDBYTE
	RETURN


LCD_SENDDATA
	movwf save
   movlw 8
	movwf counter

	bsf PORT_A,RA2
    bcf PORT_A,RA3
	call LCD_SENDBYTE
	return

 
LCD_SENDBYTE 
	

	movf save,0
	MOVWF data_in
LOOP
	clrwdt
	rlf data_in,1  ; Rotate data byte left
	btfss status,Carry					; Carry set?
	bcf PORT_A,RA0
	btfsc status,Carry
    bsf	PORT_A,RA0			; Yes, set data pin high

	bsf PORT_A,RA1	
    ; Clock the data in
 

     call halta




	bcf PORT_A,RA1			; Clock low
      
	decfsz counter,1			; Decrement LOOP, skip if =0
	 goto LOOP		; Not =0, so keep looping

	bsf PORT_A,RA3			; chip disabled

	RETURN

halta	movlw   5	  ;020h
	movwf   count1
g1	movlw    5               ;40H
	movwf   count2 
g2	decfsz  count2	
	goto 	g2		
	decfsz  count1	
	goto 	g1		
	retlw	00

 

delay1 
	MOVLW 2
	MOVWF n
			;    char i;
			;
			;    OPTION = 7;
	MOVLW .7
	BSF   0x03,RP0
	MOVWF OPTION_REG
			;    do  {
			;        clrwdt();  // only if watchdog enabled
m007x	CLRWDT
			;        i = TMR0 + 39; /* 256 microsec * 39 = 10 ms */
	MOVLW .20 ;//////////////////////////////////////////////////////////////////////////////////
	BCF   0x03,RP0
	ADDWF TMR0,W
	MOVWF i_2
			;        while ( i != TMR0)
m008x	MOVF  i_2,W
	BCF   0x03,RP0
	XORWF TMR0,W
	BTFSS 0x03,Zero_
			;            ;
	GOTO  m008x
			;    } while ( --n > 0);
	DECFSZ n,1
	GOTO  m007x
			;}
	RETURN






  		END
